Bug 1646730 (CVE-2018-18311)

Summary: CVE-2018-18311 perl: Integer overflow leading to buffer overflow in Perl_my_setenv()
Product: [Other] Security Response Reporter: Laura Pardo <lpardo>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: abhgupta, ahardin, bleanhar, bmcclain, caillon+fedoraproject, ccoleman, dbaker, dblechte, dedgar, dfediuck, dmoppert, eedri, eparis, hhorak, iarnell, jgoulding, jokerman, jorton, jplesnik, kasal, mbarnes, mchappel, mgoldboi, michal.skrivanek, mmaslano, perl-devel, perl-maint-list, ppisar, psabata, rhughes, sandmann, sbonazzo, security-response-team, sherold, sthangav, tcallawa, trankin, yozone, yturgema
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: perl 5.29.1, perl 5.26.3 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-01-21 18:54:11 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1653527, 1653528, 1653529, 1654918, 1654920, 1656293, 1659170, 1660190, 1661064, 1719431, 1719432, 1724849    
Bug Blocks: 1646752    

Description Laura Pardo 2018-11-05 22:25:40 UTC
A flaw was found in Perl versions 5.8.0 through 5.28. An Integer overflow leading to buffer overflow in Perl_my_setenv function in util.c


Upstream Patch:
https://github.com/Perl/perl5/commit/34716e2a6ee2af96078d62b065b7785c001194be

Comment 1 Doran Moppert 2018-11-23 03:57:37 UTC
Upstream ticket:

https://rt.perl.org/Public/Bug/Display.html?id=133204

Comment 4 Doran Moppert 2018-11-27 03:47:50 UTC
Acknowledgments:

Name: the Perl project
Upstream: Jayakrishna Menon

Comment 5 Doran Moppert 2018-11-30 03:18:21 UTC
Created perl tracking bugs for this issue:

Affects: fedora-all [bug 1654918]

Comment 8 Doran Moppert 2018-11-30 04:02:50 UTC
Statement:

This vulnerability is present in versions of perl included with Red Hat Virtualization Hypervisor and Management Appliance, however it is not exposed in any meaningful way. Perl is only included in these images as a dependency of components which do not manipulate ENV, and are not exposed to user input. A future update may address this issue.

Comment 10 errata-xmlrpc 2019-01-02 13:29:31 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2019:0001 https://access.redhat.com/errata/RHSA-2019:0001

Comment 11 errata-xmlrpc 2019-01-02 16:13:20 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 6

Via RHSA-2019:0010 https://access.redhat.com/errata/RHSA-2019:0010

Comment 12 errata-xmlrpc 2019-01-21 17:34:07 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2019:0109 https://access.redhat.com/errata/RHSA-2019:0109

Comment 13 Paul Harvey 2019-01-25 13:03:21 UTC
openshift-enterprise-3: notaffected. I reviewed OpenShift containers for applications with dependencies on perl and was unable to identify any where the perl interpreter would be exposed to attacker-controlled environment variables which could expose this flaw. I have not filed trackers as these images will inherit the existing perl fixes next time they are respun. See also https://access.redhat.com/articles/2803031

Comment 16 errata-xmlrpc 2019-07-16 13:45:20 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.5 Extended Update Support

Via RHSA-2019:1790 https://access.redhat.com/errata/RHSA-2019:1790

Comment 17 errata-xmlrpc 2019-07-30 09:08:07 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.4 Extended Update Support

Via RHSA-2019:1942 https://access.redhat.com/errata/RHSA-2019:1942

Comment 18 errata-xmlrpc 2019-08-07 11:35:39 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.3 Advanced Update Support
  Red Hat Enterprise Linux 7.3 Update Services for SAP Solutions
  Red Hat Enterprise Linux 7.3 Telco Extended Update Support

Via RHSA-2019:2400 https://access.redhat.com/errata/RHSA-2019:2400